/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 53)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")

(local

ghost = 0
firstTime = 1
mumble = 0

)
/******************************************************************************/
(instance public rm053 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(170 110)
					loop(1)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init()loop(2))
        (guard:init()loop(2)setPri(16))
        (zzz:init()setPri(16)loop(2)setCycle(Fwd)cycleSpeed(3))
        (bed:init()loop(1))
        (table:init()loop(2)cel(1))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
    (method (changeState intro)
        = state intro
        (switch(state)
            (case 0 = cycles 1
                (ProgramControl)
            )(case 1 = cycles 5
            )(case 2 = cycles 6
                (if(send gEgo:has(3))
                )(else
                    Print("Many hours have passed and you are in the King's prison, but fortunately 'ol Jeff is asleep.")
                    Print("Unortunately he snores and mumbles in his sleep.")
                )
            )(case 3
                (if(send gEgo:has(3))
                )(else
                    Print("This is my chance to escape."#title"You think")
                    (PlayerControl)
                    (send gGame:changeScore(1))//changescore
                )
            )(case 5 = cycles 5
                Print("You reach out and take hold of the keys.")
            )(case 6 = cycles 4
                Print("Hey, what's going on?"#title"Jeff says")
                Print("Oh my...a GHOST!"#title"Jeff says")
                Print("Feeling...light...hea...d...ugh..."#title"Jeff says")
            )(case 7 = cycles 5
                (guard:loop(8)cel(0))
                (zzz:hide())
            )(case 8 = cycles 7
                Print("Jeff has fainted and you took his keys.")
                Print("There is one for your cell and another for the storage room.")
                (send gEgo:get(4))
                (send gGame:changeScore(1))//CHANGESCORE
            )(case 9 = cycles 7
                Print("Now to take of this ridiculous sheet. I can't believe that worked!"#title"You think")
            )(case 10 = cycles 10
                (send gEgo:view(0))
                = ghost 0
            )
        )
    )
    (method (handleEvent pEvent)
        (var dyingScript)
        (super:handleEvent(pEvent))
        (if(Said('look>'))
            (if(Said('/guard,man'))
                Print("Man look at those keys just hangin' there! Close enough to touch, but he would probably notice.")
            )(if(Said('/bed,sheet,cover,mattress,cloth'))
                (if(send gEgo:has(1))
                    Print("Just a mattress without a sheet now.")
                )(else
                    Print("A make shift bed was made for you, probably because you are a high-profile prisoner.")
                    Print("Just goes to show what years of service to the King will get you! A mattress and a thin cover.")
                )
            )(if(Said('/moon,window,sky,outside'))
                Print("Sure is a beautiful night to be in prison.")
            )(if(Said('/table,glass,cup'))
                (if(not(send gEgo:has(3)))
                    Print("On top of an old wood table is a glass of water.")
                    Print("Sorry, it's not really glass though, so you can't make sharp pointy weapons from it.")
                )(else
                    Print("Nothing interesting except that those wood lines kinda look like an eyeball.")
                )
            )(if(Said('around'))
                Print("It's a dark, cool cell with all the homely furnishings...except...")
                Print("There is no toilet!")
                Print("Better find a way outa here soon!"#title"You think")
            )(if(Said('/anyword'))
                Print("Why look at that? It's quite boring.")
            )(if(Said('[ /* , !* ]'))
                Print("It's a dark, cool cell with all the homely furnishings...except...")
                Print("There is no toilet!")
                Print("Better find a way outa here soon!"#title"You think")
            )
        )

        (if(Said('talk/guard,man'))
            (if(not(firstTime))
                Print("Hey Glenn, back off. I'm tired here, so if you wake me up again, it's all over for you!"#title"Jeff says")
                = firstTime 0
            )(else
                = dyingScript ScriptID(DYING_SCRIPT)
                (send dyingScript: caller(214)
                register("The key to survival is more important than the key to the cell!")
                )
                (send gGame:setScript(dyingScript))
            )
        )
        
        (if(Said('take,get,pick>'))
            (if(Said('/sheet,cover,cloth'))
                (if(not(send gEgo:has(1)))
                    (if(<=(send gEgo:distanceTo(bed))25)
                        (send gEgo:get(1))
                        Print("You take the sheet.")
                        (bed:loop(0))
                        (send gGame:changeScore(1))//CHANGESCORE
                    )(else
                        Print("Your arms aren't that long. Go closer.")
                    )
                )(else
                    Print("You already have that Einstein.")
                )
            )(if(Said('/glass,cup,water'))
                (if(not(send gEgo:has(3)))
                    (if(<=(send gEgo:distanceTo(table))25)
                        (send gEgo:get(3))
                        Print("You empty the cup and take it.")
                        (table:cel(0))
                        (send gGame:changeScore(1))//CHANGESCORE
                    )(else
                        Print("Your arms aren't that long. Go closer.")
                    )
                )(else
                    Print("You already have that Einstein.")
                )
            )(if(Said('/key'))
                (if(not(send gEgo:has(4)))
                    (if(<=(send gEgo:distanceTo(guard))30)
                        (if(ghost)
                            (RoomScript:changeState(5))
                        )(else
                            (if(firstTime)
                                = firstTime 0
                                Print("You reach out, but the keys clank and wake Jeff up.")
                                Print("Hey Glenn, back off. I'm tired here, so if you wake me up again, it's all over for you!"#title"Jeff says")
                            )(else
                                //death Script
                                = dyingScript ScriptID(DYING_SCRIPT)
                                (send dyingScript: caller(214)
                                register("The key to survival is more important than the key to the cell!")
                                )
                                (send gGame:setScript(dyingScript))
                            )
                        )
                    )(else
                        Print("You can't reach it from there")
                    )
                )(else
                    Print("You already have his keys.")
                )
            )
        )
        
        (if(Said('use>'))
            (if(Said('/sheet,cover,cloth'))
                (if(not(send gEgo:has(1)))
                    Print("I know it's cold, but sleeping may not be the best idea right now.")
                )(else
                    Print("How is it you want to use it?")
                )
            )
        )
        
        (if(Said('wear,put/sheet,cover,cloth'))
            (if(not(send gEgo:has(1)))
                Print("You don't have that in your inventory.")
            )(else
                = ghost 1
                (send gEgo:view(14))
            )
        )
        
        (if(Said('drink/water'))
            Print("Prison water? No way man. I'm holding out for the good stuff.")
        )
        
        (if(Said('use,open,unlock/cell,door,key'))
            (if(<=(send gEgo:distanceTo(guard))35)
                (if(send gEgo:has(4))
                    (if(send gEgo:has(3))
                        Print("You unlock the door and exit.")
                        (send gRoom:newRoom(50))
                    )(else
                        Print("Before I leave and lock our friend Jeff in the cell, I better make sure I have everything.")
                    )
                )(else
                    Print("Easier said than done! The cell is locked and I don't have the key!")
                )
            )(else
                Print("I'm here. The cell door is way over there. How's this supposed to work?")
            )
        )
        
    )
    (method (doit)
        (super:doit)
        (if(<=(send gEgo:distanceTo(guard))35)
            (if(not(mumble))
                Print("...ghosts! mumble...don't! I'll faint...don't come near me...mumble..."#title"Jeff says")
                = mumble 1
            )
        )
    )
)
(instance guard of Prop
    (properties
        y 155
        x 200
        view 310
    )
)
(instance zzz of Prop
    (properties
        y 135
        x 210
        view 100
    )
)
(instance bed of Prop
    (properties
        y 83
        x 129
        view 13
    )
)
(instance table of Prop
    (properties
        y 83
        x 186
        view 13
    )
)
