/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 54)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
/******************************************************************************/
(instance public rm054 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(200 160)
					loop(3)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init())
        (if(not(send gEgo:has(5)))
            (lantern:init()loop(6)setCycle(Fwd)cycleSpeed(2))
        )(else
            (lantern:init()hide())
        )
        (guard:init()loop(4))
        (prisoner:init()loop(5))
        (zzz:init()setPri(16)loop(2)setCycle(Fwd)cycleSpeed(3))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
 
    (method (handleEvent pEvent)
        (var dyingScript)
        (super:handleEvent(pEvent))
        
        (if(Said('look>'))
            (if(Said('/guard,man'))
                Print("Sleeping on duty.")
                Print("Who hires these people?")
                Print("Wait, that's Mark! I hired him!")
            )(if(Said('/prisoner'))
                Print("No mattress for you, huh? Guess it does pay to devote your allegience to the King.")
                Print("At least when you get locked up you get something comfy.")
            )(if(Said('/moon,window,sky,outside'))
                Print("Yep, there's a moon out there.")
            )(if(Said('around'))
                Print("It's a dark, cool cell with a lantern and a sleeping guard.")
                Print("I better be quiet.")
            )(if(Said('/anyword'))
                Print("Why look at that? It's quite boring.")
            )(if(Said('[ /* , !* ]'))
                Print("It's a dark, cool cell with a lantern and a sleeping guard.")
                Print("I better be quiet.")
            )
        )
        
        (if(Said('talk/man,prisoner,guard'))
            = dyingScript ScriptID(DYING_SCRIPT)
            (send dyingScript: caller(272)
            register("Sometimes silent isn't deadly. This was one of those times.")
            )
            (send gGame:setScript(dyingScript))
        )
        (if(Said('fart,burp,shout'))
            = dyingScript ScriptID(DYING_SCRIPT)
            (send dyingScript: caller(272)
            register("Sometimes silent isn't deadly. This was one of those times.")
            )
            (send gGame:setScript(dyingScript))
        )
        
        (if(Said('open/door'))
            (if(== (send gEgo: onControl()) ctlMAROON)
                Print("There is no reason to open this gate.")
            )(else
                (if(== (send gEgo: onControl()) ctlSILVER)
                    Print("OK")
                    (send gRoom:newRoom(51))
                )(else
                    (PrintNotCloseEnough)
                )
            )
        )
        
        (if(Said('take/pick,lantern,lamp,light'))
            (if(not(send gEgo:has(5)))
                (if(<=(send gEgo:distanceTo(lantern))30)
                    Print("You silently take the lantern.")
                    (send gEgo:get(5))
                    (lantern:loop(4))
                    (send gGame:changeScore(1))//CHANGESCORE
                )(else
                    Print("You must get a little closer.")
                )
            )(else
                Print("That's funny. Why would you take what you already have?")
            )
        )

    )
)

(instance guard of Prop
    (properties
        y 155
        x 215
        view 310
    )
)
(instance lantern of Prop
    (properties
        y 160
        x 75
        view 101
    )
)
(instance zzz of Prop
    (properties
        y 135
        x 210
        view 100
    )
)
(instance prisoner of Prop
    (properties
        y 80
        x 140
        view 310
    )
)
/******************************************************************************/
